superstrict
import "bumpMap_lib.bmx"
GLGraphics 800, 600
glewInit

LoadBumpMapShader("vertexShader.glsl", "fragmentShader.glsl")

local sprite:TBumpMapSprite = LoadBumpMapSprite("color.png", "alpha.png", "bump.png")
'TBumpMapSprite ist nur ein Container-Typ fuer drei zusammengehoerige Texturen

Local timer:TTimer = CreateTimer(60)
Local frameCnt:Int, nextFrame:Int = MilliSecs()+1000
glMatrixMode GL_PROJECTION
glLoadIdentity
glOrtho 0, 800, 600, 0, -1, 1
glViewport 0, 0, 800, 600
glEnable GL_BLEND
glBlendFunc GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA
glColor4f 1, 1, 1, 1
glClearColor 1, 1, 0, 1

local stretch# = 30.0

local bg:int = _LoadTexture("bg.png") 'Laedt ein Hintergrundbild

Repeat
	Local time:Int = MilliSecs()
	If time > nextFrame Then
	
		DebugLog "FPS:"+frameCnt
		frameCnt = 0
		nextFrame = time+1000
		
	EndIf
	frameCnt :+ 1

	WaitTimer timer
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
	CheckError
	TOpenGLShader.Change(Null) ' Feste Funktionspipeline einstellen
				' Zeichnet den Hintergrund:
	glMatrixMode(GL_MODELVIEW)
	glLoadIdentity()
	glEnable(GL_TEXTURE_2D)
	glColor4f(1, 1, 1, 1)
	glBindTexture(GL_TEXTURE_2D, bg)
	glBegin(GL_QUADS)
	glTexCoord2f(0,0);glVertex3f(0, 0, 1)
	glTexCoord2f(0,4);glVertex3f(0, 600, 1)
	glTexCoord2f(4,4);glVertex3f(800, 600, 1)
	glTexCoord2f(4,0);glVertex3f(800, 0, 1)
	glEnd()
	glDisable(GL_TEXTURE_2D)
	CheckError

	TOpenGLShader.Change(bumpMapShader) ' BumpMap-Shader aktivieren
	CheckError
				' Stellt das Licht ein. Das ist die Richtung vom Mauszeiger zur Bildschirmmitte
	local x# = (mousex()/400.0)-1
	local y# = (mousey()/300.0)-1
	SetLightDirection(-x, -y, 1)
	CheckError
				' Zeichnet das Bild gedreht
	local z# = mousez()*30
	
	SetBumpMapSprite(sprite) ' uebergibt Color-, Alpha- und BumpMap an den Shader
	glVertexAttrib3f(normalVectorAttribute.location, 0, 0, 0) ' Stellt den Normalen-Vektor auf (0, 0, 0). Ich weiß nicht, was hier ein sinnvoller Wert wäre
	CheckError
	glMatrixMode(GL_MODELVIEW)
	glLoadIdentity() ' Modell gedreht in der Bildschirmmitte zeichnen
	glTranslatef(400, 200, 1)
	glRotatef(z, 0, 0, 1)
	RotateNormals(z) ' Drehung auch auf die Normalen anwenden
	glBegin(GL_QUADS)
	glTexCoord2f(0, 0) ; glVertex2f(-100, -100)
	glTexCoord2f(0, 1) ; glVertex2f(-100,  100)
	glTexCoord2f(1, 1) ; glVertex2f( 100,  100)
	glTexCoord2f(1, 0) ; glVertex2f( 100, -100)
	glEnd()
	CheckError
		' Zeichnet das Bild mit einem Knick in der Mitte
	glMatrixMode(GL_MODELVIEW)
	glLoadIdentity()
	glTranslatef(300, 490, 1)
	glBegin(GL_QUADS)
	SetLocalX(100,-stretch) ; glTexCoord2f(0  ,0  ) ; glVertex2f(-100, 0)
	SetLocalX(1, 0) ; glTexCoord2f(0.5,0  ) ; glVertex2f(0, 0-stretch)
	SetLocalX(1, 0) ; glTexCoord2f(0.5,1) ; glVertex2f(0, 200-stretch)
	SetLocalX(100, -stretch) ; glTexCoord2f(0  ,1) ; glVertex2f(-100, 200)

	SetLocalX(100,stretch) ; glTexCoord2f(1  ,0  ) ; glVertex2f(100, 0)
	SetLocalX(1, 0) ; glTexCoord2f(0.5,0  ) ; glVertex2f(0, 0-stretch)
	SetLocalX(1, 0) ; glTexCoord2f(0.5,1) ; glVertex2f(0, 200-stretch)
	SetLocalX(100,stretch) ; glTexCoord2f(1  ,1) ; glVertex2f(100, 200)
	glEnd()
	stretch :+ 10.0*(keyhit(KEY_UP)-keyhit(KEY_DOWN))

		' Zeichne ein kleines weisses Quadrat in der Bildschirmmitte
		' Hilft bei der Orientierung, wenn man mit der Maus die Lichtrichtung festlegt.

	TOpenGLShader.Change(Null)
	glMatrixMode(GL_MODELVIEW)
	glLoadIdentity()
	glDisable(GL_TEXTURE_2D)
	glColor4f(1, 1, 1, 1)
	glBegin(GL_QUADS)
	glVertex3f(400-5, 300-5, 0)
	glVertex3f(400+5, 300-5, 0)
	glVertex3f(400+5, 300+5, 0)
	glVertex3f(400-5, 300+5, 0)
	glEnd()
	flip 0
	CheckError

until keyhit(KEY_ESCAPE) or appterminate()
end
