uniform sampler2D color;
uniform sampler2D alpha;
uniform sampler2D bump;
uniform vec3 lightDir;
varying vec2 uv;
varying vec3 normVec;
varying vec2 xDir;
varying vec2 yDir;
void main() {
	vec3 color=vec3(texture2D(color, uv));
	float alpha = texture2D(alpha, uv).r;
	vec3 normal = vec3(texture2D(bump, uv));
	normal=2.0*(normal.r-0.5)*vec3(xDir,0)+ 2.0*(normal.g-0.5)*vec3(yDir,0)+vec3(0, 0, normal.b)+normVec;
	// normal ist der Normalenvektor aus der BumpMap, der auch schon richtig gedreht wurde.
	// normVec ist der interpolierte Normalenvektor, der als Vertex-Attribut uebergeben wurde
	// ich habe keine Ahnung, wie die verrechnet werden sollen
	float f = dot(normalize(normal), lightDir);
	color=color*(f*f*f)*1.375; 
	gl_FragColor=vec4(color, alpha);
}
