SuperStrict
Function CreateVector3:TVector3(x:Float, y:Float, z:Float)

		Local res:TVector3 = New TVector3
		
		res.x = x
		res.y = y
		res.z = z
		
		Return res
		
End Function

Type TVector3

	Field x#, y#, z#
	
	Method Sum:TVector3(v:TVector3)
	
		Return CreateVector3(x + v.x, y + v.y, z + v.z)
		
	End Method
	
	Method Add(v:TVector3)
	
		x :+ v.x
		y :+ v.y
		z :+ v.z
		
	End Method
	
	Method Difference:TVector3(v:TVector3)
	
		Return CreateVector3(x - v.x, y - v.y, z - v.z)
		
	End Method
	
	Method Sub(v:TVector3)
	
		x :- v.x
		y :- v.y
		z :- v.z
		
	End Method
	
	Method Product:TVector3(s:Float)
	
		Return CreateVector3(x * s, y * s, z * s)
		
	End Method
	
	Method Multiply(s:Float)
	
		x :* s
		y :* s
		z :* s
		
	End Method
	
	Method Quotient:TVector3(s:Float)
	
		If s <> 0 Then
		
			s = 1.0/s
			Return CreateVector3(x * s, y * s, z * s)
			
		EndIf
		
	End Method
	
	Method Absolute:Float()
	
		Return Sqr(x*x+y*y+z*z)
		
	End Method
	
	Method AbsoluteSquared:Float()
	
		Return x*x+y*y+z*z
		
	End Method
	
	Method Normalize()
	
		Local f# = 1.0/Sqr(x*x + y*y + z*z)
		
		x :* f
		y :* f
		z :* f
		
	End Method
	
	Method DotProduct:Float(v:TVector3)
	
		Return x * v.x + y * v.y + z * v.z
		
	End Method
	
	Method VectorProduct:TVector3(v:TVector3)
	
		Return CreateVector3(y * v.z - z * v.y, z * v.x - x * v.z, x * v.y - y * v.x)

	End Method
	
	Method AngleBetween:Float(v:TVector3)
	
		Return ACos(DotProduct(v) / (Absolute() * v.Absolute()))
		
	End Method
	
	Method Normal:TVector3(v:TVector3)
	
		Local res:TVector3 = VectorProduct(v)
		res.Normalize()
		Return res
		
	End Method
	
End Type
